




/**********************************************************



**********************************************************/
typedef unsigned char byte;
typedef unsigned int  word;
typedef unsigned long lword;

typedef unsigned char   u8;
typedef unsigned int    u16;
typedef unsigned long   u32;
typedef signed char     s8;
typedef signed int      s16;
typedef signed long     s32;

typedef unsigned char UINT8;


//==================APP DEFINE==========
//GND-DAT-VCC-CLK-RST(Writer port order)
/*...
  AS TX
                              |-------\_/-------|
              AC_KEY_IN ---1--|P00           P01|--20--- VAR ADC      //ADC0
      ICPCLK  AC05S_KEY ---2--|P17           P02|--19--- LOW_BAT_ADC  //ADC1
      ICPDAT  MO_KEY_IN ---3--|P16           P03|--18--- DCLK
                        ---4--|/RST          P04|--17--- MOSI
                        ---5--|Vss  N79E814  P05|--16--- SOUND_KEY_IN
                 SCK	---6--|P31           Vdd|--15---   
                GLED	---7--|P30           P06|--14--- CH12_SW_IN 
                 nRESET	---8--|P14           P07|--13--- CHARG_DET(DC_DETECT)
                MISO	---9--|P13           P10|--12--- DATA
    RLED/Charge_Sta   	---10-|P12           P11|--11--- NSS
                              |_________________|
			
*/	

// ========================================================
//		  MD1230 module PIN	  
//		  |-------------------|
//                |            nRESET |--1-- reset circuit
//                |              NC   |--2-- nc
//                |              PB0  |--3-- 
//                |            CLKOUT |--4-- test point(pin)
//                |               GND |--5--
//                |               VDD |--6--
//                |              DCLK |--7-- DCLK
//                |               SCK |--8-- SCK
//                |              MISO |--9--  MISO
//                |              MOSI |--10-  MOSI
//                |               NSS |--11- NSS  //P06
//                |              DATA |--12- DATA
//                | ------------------|  
//      
      
      
/*
                		    TSSOP20
                              |-------\_/-------|
            bz          ---1--|P00           P01|--20--- SP0
    ICPCLK  SP3         ---2--|P17           P02|--19--- SP1                  
    ICPDATA sim_UART    ---3--|P16           P03|--18--- SP2
                        ---4--|/RST          P04|--17--- BANK_SEL_VR        
                        ---5--|Vss  N79E814  P05|--16--- KEY   
           RLED    	---6--|P31           Vdd|--15---   
           GLED 	---7--|P30           P06|--14--- nRESET    
  (TX:NSS)LNA_EN        ---8--|P14           P07|--13--- DIO0(DCLK)                     
  (TX:DATA) NSS	        ---9--|P13           P10|--12--- SCK      
           MOSI	        ---10-|P12           P11|--11--- MISO
                              |_________________|			        			        
       *(P12:pull up 10k)                   
       *BANK_SEL_VR(315/433/868/915)
                 (R=33K/47K/80K/90K3489üǡ47K.
       *д˳GND--DAT--VCC---CLK--RST2.54MM.
       *ӦMCUλ PIN5/PIN3/PIN15/PIN2/PIN4
                                     		        			        
*/	
/**********************************************************
IO port define

**********************************************************/
#define BZ		P00
#define nRESET		P06 //I HZ
#define DCLK		P07 //O
#define SCK		P10 //O
#define MISO		P11 //I
#define MOSI            P12 //O
#define DATA		P13 //O
#define NSS		P14 //O

#define SOUND_KEY_IN    P05 //I
#define GLED            P30 //O
#define RLED		P31 //O

#define sim_uart_tx     P16 //O



//                   

//====================================================



/**********************************************************
**Constant define
**********************************************************/


#define c_acmode	0
#define c_momode	1
#define c_bzmode	2
#define c_ltmode	3    
#define c_bzmomode  5     
#define c_none_mode 0x0f

#define c_rfwindows 5		//120ms		   4:6
#define c_rf_off_time 10 //9 	   //240ms;15
#define c_rf_short_off_time 7	//used fast clock timer2 
//#define c_rf_long_off_time 3	//used wdt as the off time under unit off status



#define c_sleep_time   31 //5 31//1min
#define c_full_G	0
#define c_half_O	1
#define c_low_R		2
#define c_low_off	3
	
#define c_onoff_key    1
#define c_none_key     0

#define KBI_Enable          0xFF
#define KBI_Level           0x00

#define c_ac_key  1
#define c_ac05s_key 2
#define c_sound_key 3
#define c_mo_key   4

#define c_ch1no 0
#define c_ch2no 1

#define c_var_adc  0//adc0
#define c_lb_adc   1 //adc1



/**********************************************************
**Extern variable define(RAM define)
**********************************************************/
u8  gb_Temp[5];
u8  gb_TxBuf[6];                                  //tx data buffer


u16 gw_RF_SentInterval;                             //Send interval

u8  gb_RF_RSSI;                                     //RF RSSI signal

unsigned char  gb_FreqBuf_Addr;                                //RF center frequency cache address
unsigned char  gb_RateBuf_Addr;


u8	gb_EA_bit_bak;

u8 FreqBuf_Addr;
u8 RateBuf_Addr;


u8 gb_TH0;
u8 gb_TL0;
u8 gb_lb_test_cnt;

u8 f_key_release;
u8 f_unit_on;
u8 gb_KBI_int_flag;
u8 gb_lb_test_flag;
u8 f_low_bat;
u8 gb_sp89_flag;	//868/915mhz 2015/2/7 14:46
u8 gb_charge_flag;
u8 f_como;
u8 f_en_tx;
u8 f_en_det_charge;
u8 f_wdt_100ms_int;

u8 f_led_var_flash;
u8 led_var_flash_cnt;
u8 led_var_flash_time;
       		     
       		     
u8 gb_sec_cnt;
u16 gb_auto_sleep_cnt;
u8 gb_key_hold_cnt;
u8 gb_bat_status;
u8 gb_bat_off_cnt;

u8 gb_LocalIDL;
u8 gb_LocalIDH;
u8 gb_LocalModel;


u8 gb_led_on_time;
u8 gb_led_on_step;
u8 gb_led_duration_cnt;
u8 gb_wr2;

u16 gb_ADCL;
u16 gb_ADC;
u16 VarADCLast;
u8 gb_ADC_sample_cnt;


u8 f_en_var_test;
u8 f_var_change;

u16 VarADCcnt[4];
u8 VarADCIndex;
u8 mo_level;
u8 ac_level;

u8 gb_LED_flash_cnt;
u8 gb_RLED_flash_duration_cnt;

//u32 u32Baudrate;

u8 key_name;
u8 keydebounce;
u8 gb_key_debounce_flag;

u8 gb_charge_debounce_time;
u8 gb_charge_debounce_flag;

u8 gb_mode;
u8 cnt_500ms;
u8 cnt_31ms;
u8 ch_no;
u8 trans_id;
u8 tx_cmd;
u8 f_tx_err;
u8 ac_level;
u8 mo_level;
u8 f_test_mode;


code u8 TXID[8] _at_   0x1ff0;// 

