
// ========================================================
//		  MD1230 module PIN	  
//		  |-------------------|
//                |            nRESET |--1-- reset circuit
//                |              NC   |--2-- nc
//                |              PB0  |--3-- 
//                |            CLKOUT |--4-- test point(pin)
//                |               GND |--5--
//                |               VDD |--6--
//                |              DCLK |--7-- DCLK
//                |               SCK |--8-- SCK
//                |              MISO |--9--  MISO
//                |              MOSI |--10-  MOSI
//                |               NSS |--11- NSS  //P06
//                |              DATA |--12- DATA
//                | ------------------|  
//      
// ========================================================

//#include "SH79F166A.h"
//#include "type.h"
//#include "MCU_IO_Define.h"
#include "MD1230.h"
#include <absacc.h>
//#include "lcd.h"
//#include "delay.h"
//#include "dm_spi.h"
//#include "lcd.h"
//#include "keyscan.h"




extern u8 f_tx_err;
extern u8 f_en_tx;
//extern u8 f_500ms;
extern u8 cnt_500ms;

extern u8 key_name;      
extern u8 FreqBuf_Addr;
extern u8 RateBuf_Addr;
extern u8 cnt_31ms;
extern u8 trans_id;
extern u8 gb_bat_status;
extern u8 gb_mode;
extern u8 ch_no;
extern u8 ac_level;
extern u8 mo_level;
extern u8 tx_cmd;
extern u8 gb_TxBuf[6];

/**********************************************************
**Parameter table define
**********************************************************/




code unsigned int MD1230FreqTbl[4][3] = 
{ 
  {0x054e, 0x06c0, 0x0700}, //315MHz 
  {0x056c, 0x0680, 0x0700}, //434MHz
  {0x05d9, 0x0600, 0x0700}, //868MHz  <---
  {0x05e4, 0x06c0, 0x0700}, //915MHz
};

code unsigned int MD1230RateTbl[4][2] = 
{
  {0x0168, 0x022b},         //BR=1.2k
  {0x0134, 0x0215},         //BR=2.4K 
  //{0x011A, 0x020B},       //BR=4.8K BW=83.333K
  {0x010D, 0x0205},         //BR=9.6K BW=83.333K
  {0x0103, 0x0241},	    //BR=38.4K   off mode high bitrate <--
};                              

//normal datarate
code unsigned int MD1230ConfigTbl[4] = 
{ 
	
  0x0302,		//RegFdevMsb(0x03) =35khz
  0x043d,		//RegFdevLsb(0x04) =35khz
  
  0x130f,		//FegOcp(0x12),=disable OCP
  
  0x0000,		//RegMode(0x00),FSK Sleep with no shapping
 
};
//high speed datarate
code unsigned int MD1230ConfigTb1_hr[4] = 
{ 
	
  0x0303,		//RegFdevMsb(0x03) =53khz
  0x046b,		//RegFdevLsb(0x04) =53khz
  
  0x130f,		//FegOcp(0x12),=disable OCP
  0x0000,		//RegMode(0x00),FSK Sleep with no shapping
 
};

code unsigned int MD1230PowerTb[6] = 
{       
  0x087f,		//(addr,value) +17dbm
  0x087d,		//+15dbm
  0x087c,		//+14dbm
  0x087b,		//+13dbm
  0x0879,	 	//+11dbm
  0x0876,		//+8dbm
};




/**********************************************************
**Variable define
**********************************************************/
                              //State stable flag



/**********************************************************
**Name:     MD1230_Config

**********************************************************/
void MD1230_Config(void)
{
  unsigned char i;
     FreqBuf_Addr=3;//2; //868mhz
     RateBuf_Addr=1; //2.4khz
  for(i=0;i<3;i++)                      
    SPIWrite(MD1230FreqTbl[FreqBuf_Addr][i]);             //setting frequency parameter
  for(i=0;i<2;i++)
    SPIWrite(MD1230RateTbl[RateBuf_Addr][i]);             //setting rf rate parameter
 
   
   SPIWrite(MD1230PowerTb[0]); //+17dbm							 //normal working rate
   for(i=0;i<4;i++)
   SPIWrite(MD1230ConfigTbl[i]);
                             //setting base parameter
}




/**********************************************************

**********************************************************/
void MD1230_Sleep(void)
{
  SPIWrite(0x0000);                                        //Sleep
 }

/**********************************************************

**********************************************************/
/*
void MD1230_Standby(void)
{
  SPIWrite(0x0010);
}


  */

/**********************************************************

**********************************************************/

void MD1230_TEST_TX(void)
{
  MD1230_Config();
  SPIWrite(0x0034);	
}	


/**********************************************************

**********************************************************/
void MD1230_EntryTx(void)
{
  SPIWrite(0x0030);	
}	
/**********************************************************

**********************************************************/
void MD1230_TxByte(u8 txbyte)
{
   u8 i,k;
   cnt_31ms=0;
   cnt_31ms=0;
   f_tx_err=0;
   k=0x80;
   for(i=0;i<8;i++)
     {
     
     while(DCLK)
       {
     	if(cnt_31ms>3)
     	 {
     	   f_tx_err=1; 
     		break;
     	  }
        }
    // cnt_31ms=0;  
     while(DCLK!=1)
        {
         if(cnt_31ms>3)
          {
            f_tx_err=1;	
            break;	
        	}	
        }
     //at DCLK rising edge changed data
     if(k&txbyte)
      DATA=1;
      else
      	DATA=0;
      k>>=1;
      
	}	
	
}	



//=============TX--------TX--------TX data===================

/**********************************************************
**Name:     MD1230_TxPacket
**Function: Check HC1208 send over & send next packet
**Input:    none
**Output:   
	MODE	TYPE+MODE
	CH(7,6)+IDH
	IDL
	LEVEL
	cmd	CMD+trand_ID
	CRC

	
		 rf_crc_8(gb_RxData[0]);   //type|mode
		 rf_crc_8(gb_RxData[1]);   //IDH
		 rf_crc_8(gb_RxData[2]);   //IDL
		 rf_crc_8(gb_RxData[3]);   //level
		 rf_crc_8(gb_RxData[4]);   //TX remote on,off command, =0x00 no,=0x11 on or off command
		 	
**********************************************************/
unsigned char MD1230_TxPacket(void)
{ 
        u8 i;
	MD1230_EntryTx();
	//f_en_tx=0;
      	//Delayn(5);
      for(i=0;i<2;i++)
      {


      	MD1230_TxByte(0xaa); //Premble bit(for decode sampling sync bit)	
      	MD1230_TxByte(0xaa);	
      	MD1230_TxByte(0xaa);	
      	MD1230_TxByte(0xaa);	//SYNC 
  	MD1230_TxByte(0x56);//(0x26); //SYNC WORD:0x2696
  	MD1230_TxByte(0x78);//SYNC 0XAA5678 //(0x96);
  	MD1230_TxByte(gb_TxBuf[5]);
  	MD1230_TxByte(gb_TxBuf[4]);
  	MD1230_TxByte(gb_TxBuf[3]);
  	MD1230_TxByte(gb_TxBuf[2]);
  	MD1230_TxByte(gb_TxBuf[1]); //CMD,Tr_ID
  	MD1230_TxByte(gb_TxBuf[0]); //CRC
       }
   return f_tx_err;
}
	
/*==============================================

MSB-----------LSB
type-mode+ch-idh+idl+level+cmd+Tr_id+CRC
4bit 4bit 2b 6b   8b   8b  4b   4b    8b

remark:
 type=8~15
 mode=0,1,2,3,4
 ch=1,2,3,4
 (idh)(idl)=00~2^14
 cmd=0~15(high b7-b4)
 Tr_id=0~15(low b3-b0)
//08 04 01 B1 43 3C 1B 01 D7
=================================================*/
void Tx_Signal(void)
{
	u8 crc,j=0;
	u8 KEY_BUF0=0,KEY_BUF1=0XFF;
	u8 temp;
	u8 keydebounce=0;


        

  if((ac_level!=0)||(gb_mode==c_momode)||(gb_mode==c_bzmode))
  {
	trans_id++;
	if(trans_id>15)
		trans_id=0;
	
	MD1230_Config();
	Delayn(5);	     //5ms
	MD1230_EntryTx();
	Delayn(1);	     //1ms

//	SendOut(trans_id);
	//if(f_test_mode)
	/*
	switch(gb_bat_status)
	{
	case 1:
		GLED=0; //ON green
		RLED=1;	
		break;
	case 2:
		GLED=0;
		RLED=0; //orange
		break;
	default:
		GLED=1;
		RLED=0; //red
		break;
	}	
	
        */
        
        
        GLED=0;  //ON green (ignore battery status)
        RLED=1;
  
        gb_TxBuf[5]=0xb0;  //z886a
	gb_TxBuf[5]|=gb_mode; //mode=ac,motor,bz,light
	gb_TxBuf[4]=ch_no<<6;
	gb_TxBuf[4]|=gb_LocalIDH;//idh;
	gb_TxBuf[3]=gb_LocalIDL;//idl;
	
	gb_TxBuf[2]=ac_level;
	
	if(key_name==c_mo_key)
	 {
	   gb_TxBuf[2]=mo_level;
	}
	
	tx_cmd=0x0;
	if(f_como==1) //f_como=1/0: continous/short 0.5s
	    tx_cmd=0x10;	
		
	gb_TxBuf[1]=tx_cmd;//<<4;
	gb_TxBuf[1]|=trans_id;
	
	crc=0xff;
	crc=rf_crc_8(crc,gb_TxBuf[5]);
	crc=rf_crc_8(crc,gb_TxBuf[4]);
	crc=rf_crc_8(crc,gb_TxBuf[3]);
	crc=rf_crc_8(crc,gb_TxBuf[2]);
	crc=rf_crc_8(crc,gb_TxBuf[1]);
	gb_TxBuf[0]=crc;
	//SendOut(gb_TxBuf[5]);
	//SendOut(gb_TxBuf[4]);
	//SendOut(gb_TxBuf[3]);
	//SendOut(gb_TxBuf[2]);
	//SendOut(gb_TxBuf[1]);
	//SendOut(gb_TxBuf[0]);

        cnt_500ms=0;
      while(j<33)
       {	
       	      	    
       	    KEY_BUF0=ReadKeyIN();
       	
  	   if(MD1230_TxPacket()==1)
	  	break;
	   
	    KEY_BUF1=ReadKeyIN();
	    
	    if(KEY_BUF0==KEY_BUF1)
	      {
		            temp=c_none_key;
		            if(KEY_BUF0==0X01)
			       temp=c_ac_key;
			       
			    if(KEY_BUF0==0X02)
			       temp=c_ac05s_key;
			       
			    if(KEY_BUF0==0X04)
			       temp=c_sound_key;
			       
			    if(KEY_BUF0==0X08)
			       temp=c_mo_key;

		 	    if((temp==c_none_key)||(temp!=key_name))
				break;
	      }

	if(cnt_500ms>15)  //300ms (150/20)
	 {
	   cnt_500ms=0;
	   j++;
	   if(f_como==0) //f_como=1/0: continous/short 0.5s
	     {
	   	j=90;
	        break;
	     }
	    
         }
        }
        
        
        	
        MD1230_Sleep();
	RLED=1;
	GLED=1;	
	
	while(1)
	{
	    KEY_BUF0=ReadKeyIN();
    		
    		
             Delayn(10);  //10ms
   
	
            KEY_BUF1=ReadKeyIN();
    		
    		
	  if((KEY_BUF0==KEY_BUF1)&&(KEY_BUF0==0))
	  break;
	     

	}


        MD1230_Sleep();
	RLED=1;
	GLED=1;	
   }
    else if(ac_level==0)
    	
    {
    	GLED=1;
    	RLED=0;	
    	while(1)
	{
	    KEY_BUF0=ReadKeyIN();
    		
    		
             Delayn(10);  //10ms
   
	
            KEY_BUF1=ReadKeyIN();
    		
    		
	  if((KEY_BUF0==KEY_BUF1)&&(KEY_BUF0==0))
	  break;
	     

	}
	
	RLED=1;
	GLED=1;
    }


    	
  
 	 
}

/**********************************************************
**Name:    
**Function: 
**Input:    none
**Output:   none
**********************************************************/	
u8 ReadKeyIN(void)
{
	    u8 KeyINBuf=0;
	   	  
    	   
    		
    	    if(SOUND_KEY_IN==0)
    		KeyINBuf|=0X04;
    		
    	   
	    return KeyINBuf;	
}    		

//=======================================
 unsigned char rf_crc_8(unsigned char wr2,unsigned char temp)
{
	u8 i;
	wr2^=temp;		//xor
	for(i=0;i<8;i++)
	{
	 if((wr2&0x01)!=0)
	 	{wr2>>=1;
		 wr2&=0x7f;
	 	wr2^=0x8c;
	      }
	 else
	 {
	 wr2>>=1;
	 wr2&=0x7f;
	 
	 }
	 
	 		
	}
	return wr2;
}