//MD
//2021
	
#define Uart_Port_Sel   0x00
// ========================================================
#include <stdio.h>
#include <intrins.h>
#include "N79E81x.h"
//#include "Typedef.h"
//#include "Define.h"
//#include "Common.h"
//#include "Version.h"

#include "WDT.h"
#include "MD1230_MCU_Define.h"
#include "function_arg.h"
#include "SPI.c"
#include "MD1230.c"



void InitPort(void);
void Init_MCU_Reg(void);
void Init_MCU_RAM(void);
void timer1_init(void);
void timer2_init(void);
void Uart_init(void);
void Init_WDT(void);
void Init_WDT1(void);
void ISR_timer(void);





void timer2_init(void);
void Init_PWM(void);  
void Init_ADC(u8 adcch);
 

void Timer0_ISR(void); 
void INT0_ISR(void);
void INT1_ISR(void);
void Timer1_ISR(void);
void Timer2_ISR(void);
//void I2C_ISR(void);
void KBI_ISR(void);
//void BOD_ISR(void);
//void SPI_ISR(void);
void WDT_ISR(void);
void ADC_ISR(void);
//void Capture_ISR(void);
//void PWM_Brake_ISR(void);
void Stop_PWM(void);
void LowBat_Detect(void);
//void delay_x5ms(void);
void key_scan(void);

//void InitialUART0_Timer1(u32 u32Baudrate);
//void Send_Data_To_PC (u8 c);
		  
//void mo_run(void);
//void BPS_Delay(void);
//void SendOut(unsigned char tx_buf);

void Charg_Detect(void);

void Var_Measure(void);
 void led_color(void);
 //void LowBat_Detect(void);

/**********************************************************
**Name:    
**Function: 
**Input:    none
**Output:   none
**********************************************************/

//void Enabled_Brake_Function(void)
//{
//    PWMCON1 = 0x30;                    // PWM is running. PWM will be stopped when P0.2 is low level.
//}

    
/**********************************************************
**Name:    
**Function: 
**Input:    none
**Output:   none
**********************************************************/
//-----------------------------------------------------------------------------------------------------------
//void Enable_ADC_Interrupt(void)
//{
//    EADC = 1;
//    EA = 1;
//}
/**********************************************************
**Name:     PowerUpDelay
/*==================================================================*/
void main(void)
{ 
  	Delayn(200);

  	Init_MCU_Reg();                                               //PIC16 Register Initialization
   	InitPort();                                              //PIC16 IO port Initialization
  	
  	//timer0_init();
  	timer2_init();
  	//Init_PWM(); 
  	Init_WDT();  
  	Init_ADC(c_var_adc);
 
        MD1230_Config();
        GLED=0;
        RLED=0;
        Delayn(100);
 
        GLED=1;
        RLED=1;
        f_test_mode=0;
        if(SOUND_KEY_IN==0)		//enter RF test mode
	 {
	   Delayn(100);
	   if(SOUND_KEY_IN==0)
	    {
		MD1230_TEST_TX();
		 while(SOUND_KEY_IN==0)
		 {
		   RLED=1;
		   GLED=0;
		   Delayn(220);	       //220ms
		   RLED=0;
		   GLED=1;
		   Delayn(100);	//100ms
		   f_test_mode=1;
		 }
	   }
	} 

 	Init_MCU_RAM();
   
        BZ=0;
        MD1230_Sleep();
      
      while(1)
       { 
	key_scan();
        if(f_en_tx)
         {
           Tx_Signal();
           f_en_tx=0;           
         }          
      if(f_unit_on==0)
        {        	
   	   MD1230_Sleep();
   	   
   	   f_led_var_flash=0;

	   Init_WDT1();
	   EA=0;
	  // GLED=0;
	  // RLED=0;
	   ET0 = 0;  
	   ET2 = 0;
	   f_wdt_100ms_int=0;
	   //WDTF=0;
	//EWDI= 0;
  	   //SendOut(0x78);
	   KBLS0 =0X00;							//P07 as DC CHARGE and edge changed
	   KBLS1 =0X80;							//KBLS1.7 : KBLS0.7=10 edge changed
	    			                		//P05 as key input(falling)
	                 						//KBLS1.5,KBLS0.5=00 Falling edge for key input

           KBIF = 0x00;                        	//Clear KBF
	   KBIE = 0XA1;							//KB7,KB5(KEY),kb0 EN INT  
	   EKB = 1;     					    //Enable KBI Interrupt
           EA  = 1;                            	//Enable EA
	//   var_bat_gnd=1;
	   PCON |=0x02;							//power down
	   _nop_();
	   _nop_();
           GLED=1;
           RLED=1;
	     //scan key press and charge every 0.1s by wdt
	  if(SOUND_KEY_IN==0)
	 
	    { 
	       f_unit_on=1;	 
	       timer2_init();
	       Init_WDT();
	       gb_auto_sleep_cnt=c_sleep_time;
	     
	    }
         
 	}	
     }
}

/**********************************************************
**Name:     InitPort
**Function: Initialize Port
**Input:    none
**Output:   none
**********************************************************/
void InitPort(void)
{
   //P0:	p0.4,1,0 OUT; P0.7,0.6,0.5,0.3,0.2 input (׼˫ģʽʱΪ룬дʱΪ
   //PxM1 PxM2=00 ׼˫ģʽ
   //         =01 ģʽ
   //         =10 ģʽ
   //         =11 ©ģʽ
        P0M1=0x00;//00000000
	P0M2=0x80;//10000000

	P1M1=0x02;//00000010
	P1M2=0x1D;//00011101

	
	P3M1&=0XFC;	
	P3M2|=0X03;	

 	//LNA_EN=0;
	//nRESET=0;
	MOSI=0;
	NSS=1;  
	//SCK=0;
	
	//AC_OUT=1;
	//BZ_OUT=1;
	//MO_OUT=1;
	//GLED=1;
	//RLED=1;
	//BZ_OUT=0;
		//AC_OUT=0;
		//MO_OUT=0; 
 
}
/**********************************************************

***********************************************************/
void Init_MCU_RAM(void)
{
	
	gb_led_on_time=3;
   	gb_led_duration_cnt=1;
	gb_led_on_step=0;
   	gb_auto_sleep_cnt=c_sleep_time;//1800;

   	f_unit_on=0x01;
	gb_KBI_int_flag=0x0;
   	gb_lb_test_flag=0x0;
   	f_low_bat=0;
   	f_en_tx=1;
   	f_en_var_test=1;
   	gb_charge_flag=0;
   	gb_charge_debounce_time=20;	//500ms //100;		//2s
   	gb_charge_debounce_flag=0;
	VarADCIndex=0;
	gb_bat_status=c_full_G;
	f_led_var_flash=0;
        led_var_flash_cnt=0;
        led_var_flash_time=0;
	
	
	
}	
/**********************************************************
ƣInit_MCU_Reg
ܣ
**********************************************************/
void Init_MCU_Reg(void)
{
	//DIVM=0X01;			//5.5296MHZ	fsys=fosc/(2(DIVM+1))	@22.1184MHZ
       KBLS1 =0X00;			//KBLS1.5,KBLS0.5=00 Falling edge for key input
       KBLS0=0x00;
       KBIF = 0x00;                        // Clear KBF
       KBIE = 0X20;						//KB5(KEY) EN INT  
       EKB = 1;     					  // Enable KBI Interrupt
       EA  = 1;                            // Enable EA
//adc
}

/**********************************************************
**Name:     Init_PWM
**Function: pwm Initialization
**Input:    none
**Output:   none
**********************************************************/
/*
void Init_PWM(void)
{
     // BZ_OUT=1;
	//PWMP=;
//    PWMPH = HIBYTE(PWM_shadow);         // PWM Period
//    PWMPL = LOBYTE(PWM_shadow);
    //PWMCON0 = 0xD0;                     // Enable PWM and select auto reload mode
	PWMCON0 = 0x00;//
    PWMCON1 = 0x00;//
    PWMCON2 = 0x00;//
        _nop_ ();      // NOP
		BZ_OUT=0;
		AC_OUT=0;
		MO_OUT=0;
}

*/
void Init_WDT(void)
{
    
    EA = 0;
    TA = 0xAA;
    TA = 0x55;
	WDCON0|=0X40;						// CLEAR WDT TIMER COUNTER
    TA = 0xAA;
    TA = 0x55;
	WDCON0|=0X80;						//ENABLE WDT TO RUN

	TA=0XAA;
	TA=0X55;
	WDCON0|=0x07;//0X06;						//SELECT WDT DIV (INTERVAL LENGTH)

	TA=0XAA;
	TA=0X55;
	WDCON1&=0XFE;						//Disable watchdog Timer Reset
	EWDI=1;								//Enable Watchdong Timer interrupt

	TA=0XAA;
	TA=0X55;
	WIDPD=1;
	EA=1;

 }

  void Init_WDT1(void)
{
  /*  
    EA = 0;
    TA = 0xAA;
    TA = 0x55;
	WDCON0|=0X40;						// CLEAR WDT TIMER COUNTER
    TA = 0xAA;
    TA = 0x55;
	WDCON0|=0X80;						//ENABLE WDT TO RUN

	TA=0XAA;
	TA=0X55;
	WDCON0|=0x02;//102ms //0x07;//0X06;						//SELECT WDT DIV (INTERVAL LENGTH)

	TA=0XAA;
	TA=0X55;
	WDCON1&=0XFE;						//Disable watchdog Timer Reset
	EWDI=1;								//Enable Watchdong Timer interrupt

	TA=0XAA;
	TA=0X55;
	WIDPD=1;
	EA=1;
	*/
	   
    EA = 0;
    TA = 0xAA;
    TA = 0x55;

	WDCON0|=0X40;						// CLEAR WDT TIMER COUNTER
    TA = 0xAA;
    TA = 0x55;
	//WDCON0|=0X80;						//ENABLE WDT TO RUN
        WDCON0=0xFC;        //WDTEN/WDCLR/WDTF/WIDPD/WDTRF/WPS2/WPS1/WPS0
		           // 1     1      1   1     1	    1   0    0
			   //                                204.8ms
       // WDCON0=0xFD;        //WDTEN/WDCLR/WDTF/WIDPD/WDTRF/WPS2/WPS1/WPS0
		           // 1     1      1   1     1	    1   0    1
			   //                                405.6ms

	//TA=0XAA;
	//TA=0X55;
	//WDCON0|=0x02;//102ms //0x07;//0X06;						//SELECT WDT DIV (INTERVAL LENGTH)

	TA=0XAA;
	TA=0X55;
	WDCON1&=0XFE;						//Disable watchdog Timer Reset
	EWDI=1;								//Enable Watchdong Timer interrupt

	TA=0XAA;
	TA=0X55;
	WIDPD=1;
	EA=1;

 }
 /**********************************************************
**Name:     Init_ADC
**Function: ADC Initialization
**Input:    none
**Output:   none
**********************************************************/
void Init_ADC(u8 adcch)
{
 	P0DIDS|=0X06;		//disable P0.2 P0.1 digital function
	P0M1|=0X06;             //ADC0(P0.1),ADC1(P0.2) is hz-input only mode
	P0M2&=0XF9;
	ADCI=0;
	ADCS=0;
	
	if(adcch==c_var_adc)
	 {
	    AADR2=0;   			//ADC0(P0.1) as var ADC channel fuction
	    AADR1=0;
	    AADR0=0;
	}
	
	
	else if(adcch==c_lb_adc)
	 {
	    AADR2=0;   			//ADC1(P0.2) as low bat ADC channel fuction
	    AADR1=0;
	    AADR0=1;
	}
	
	
	
	ADCEX=0;			//DIS EXT P1.4 trigger adc start
	ADCCON1&=0XFD;		//fsys/4 clock is ADC clock
	EADC=1;
	EA=1;
	ADCCON1 |=0X80;		//enable ADC function
 }
/**********************************************************
**Name:     bz_output
**Function: buzzer output 1khz
**Input:    none
**Output:   none
**********************************************************/


/**********************************************************
**Name:     timer2_init
**Function: timer2 Initialization
**Input:    none
**Output:   none
timer2 is 16bit count up timer
;fsys=11.0592mhz
;scale:1/32
;Td=32/11.0592=2.893519us
20000/Td=1AFF->6911 (dec)
**********************************************************/
void timer2_init(void)
{
    T2MOD = 0xb0;                       //LDEN=1,T2DIV=011. Enabled auto-reload and timer2 clock divider is 1/32
    TR2=0;
	CP_RL2=0;							//TIMER MODE
    TH2 =(65536-6911)/256;                         // Initial values
    TL2 =(65536-6911)%256;
    RCOMP2L = TL2 ;                      // Reload values initialize
    RCOMP2H = TH2 ;

	TR2=1;								//timer2 running
	ET2=1;								//enable timer2 interrupt
    EA = 1;                             // Enable interrupts
    
}



//-----------------------------------------------------------------------------------------------------------
void Timer0_ISR(void) interrupt 1   // Vector @  0x0B
{
	//1.09us
    TF0 = 0;                        // Reset timer0 interrupt flag (already done by hardware)
    
    


}  
//-----------------------------------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------------------------------
void INT0_ISR(void) interrupt 0          // Vector @  0x03
{
    //P0 = 0xFF-1;
    IE0=0;
}

//-----------------------------------------------------------------------------------------------------------
void INT1_ISR(void) interrupt 2          // Vector @  0x13
{
    //P0 = 0xFF-3;
    IE1=0;
}
//-----------------------------------------------------------------------------------------------------------
void Timer1_ISR(void) interrupt 3        // Vector @  0x1B
{
    //P0 = 0xFF-4;
    TF1=0;
    
       
   
    
    
    
}

//-----------------------------------------------------------------------------------------------------------
void Timer2_ISR(void) interrupt 5        // Vector @  0x2B
{								   		//about 20ms
    
    TF2=0;
//	RLED=~RLED;		  //test 

	cnt_31ms+=1;
	f_en_var_test=1;
	f_en_det_charge=1;
	
	
	
	cnt_500ms++;
	
       if((f_key_release==0x00)&&(gb_led_on_time!=0x0))
 	 {
 	        gb_led_on_time--;
	        if(gb_led_on_time==0x0)
	       {  
	       	  switch(gb_bat_status)
	             {
			 case c_full_G:
			 	switch(gb_led_on_step)
			 	{
			 	  case 0:
			 	   	   gb_led_on_time=3;//10;
			 	   	   gb_led_on_step=1;
			 	   	   RLED=1;
			 	   	   GLED=1;
			 	   	   break;
			 	  case 1:
			 	  	   gb_led_on_time=3;//10;
			 	  	   gb_led_on_step=2;
			 	  	   RLED=1;
			 	  	   GLED=0;
			 	  	   break;
			 	  case 2:
			 	  	   gb_led_on_time=0;
			 	  	   gb_led_on_step=0;
			 	  	   RLED=1;
			 	  	   GLED=1;
			 	  	   break;	
			 	 default:
			 	 	   break;
			 	 }
			         break;
			
			 case c_low_R:
			       RLED=1;
			       GLED=1;
			       break;
			 default:
			 	break;
	         	}
                 }		  
           
      	   
  	 }
	    
     if(gb_charge_debounce_time!=0)
	{
	 gb_charge_debounce_time--;
	 if(gb_charge_debounce_time==0)
	    gb_charge_debounce_flag=1;
	  }




	   //2S
	   gb_sec_cnt++;
	 if(gb_sec_cnt>100)	//two second
	 {	gb_sec_cnt=0;
	 	 //f_en_var_test=1;
         	gb_auto_sleep_cnt--;
         	if(gb_auto_sleep_cnt==0)
         		{
         		   f_unit_on=0;	//enter sleep mode(turn off unit)
	
		           gb_KBI_int_flag=0;
			   RLED=1;
			   GLED=1;
				}
     }

   
}
//-----------------------------------------------------------------------------------------------------------
void I2C_ISR(void) interrupt 6           // Vector @  0x33
{
    P0 = 0xFF-7;
    SI=0;
}
//-----------------------------------------------------------------------------------------------------------
void KBI_ISR(void) interrupt 7           // Vector @  0x3B
{
    //P0 = 0xFF-8;
    //clr_KBIF0;
    KBIF = 0x00;                        // Clear KBF flag
    gb_KBI_int_flag=1;
	
}
//-----------------------------------------------------------------------------------------------------------
void BOD_ISR(void) interrupt 8           // Vector @  0x43
{
    //P0 = 0xFF-9;
//    BOF=0;
}
//-----------------------------------------------------------------------------------------------------------
void SPI_ISR(void) interrupt 9           // Vector @  0x4B
{
    //P0 = 0xFF-10;
//    clr_SPIF;
}
//-----------------------------------------------------------------------------------------------------------
//10K RC->100US  +/-50%
void WDT_ISR(void) interrupt 10          // Vector @  0x53
{							   			// 860ms
    //P0 = 0xFF-11;
	//for LED flashing
	//for learning mode timer
	EA=0;
	TA=0XAA;
	TA=0X55;
	WDCON0|=0X40;				//CLEAR WATCHDOG TIMER COUNTER
	EA=1;

	EA=0;
	TA=0XAA;
	TA=0X55;
	WDCON0&=0XDF;			//clear watchdog timer interrupt;
	EA=1;
	 // GLED=~GLED;
	f_wdt_100ms_int=1;
	if(f_unit_on==1)
	{      
	      //if((gb_led_duration_cnt!=0)&&(gb_charge_flag==0)&&(f_key_release==0))
	      if((gb_charge_flag==0)&&(f_key_release==0)&&(f_led_var_flash==0))
	      
	        {
	          gb_led_duration_cnt--;

	          if(gb_led_duration_cnt==0x0)
	          {
	            gb_led_on_time=3;//10;
	            gb_led_on_step=0;
		    gb_lb_test_flag=1;	  
		    gb_led_duration_cnt=2;
		   
		    switch(gb_bat_status)
	             {
					 case c_full_G:
					      RLED=1;
					      GLED=0;
					     break;
					  
					 case c_half_O:
					       //RLED=0;
					       //GLED=0;
					       RLED=1;
					       GLED=0;//only the two level:Green/Red
					       
                                             break;
						  
					 case c_low_R:
					 
					       RLED=0;
					       GLED=1;
					       break;
					 case c_low_off:
					 
					       RLED=1;
					       GLED=1;
					       break; 

		     }

	          }
	     }
			
	}		
		
       			
       
}
//-----------------------------------------------------------------------------------------------------------
void ADC_ISR(void) interrupt 11          // Vector @  0x5B
{
   // P0 = 0xFF-12;
    ADCI=0;


}
//-----------------------------------------------------------------------------------------------------------
void Capture_ISR(void) interrupt 12      // Vector @  0x63
{
    //P0 = 0xFF-13;
//    CAPF0=0;
}
//-----------------------------------------------------------------------------------------------------------
void PWM_Brake_ISR(void) interrupt 14    // Vector @  0x73
{
    //P0 = 0xFF-14;
//    BKF=0;
}
//-----------------------------------------------------------------------------------------------------------


/**************************************************************
Name: key_scan

key scan and process
***************************************************************/
void key_scan(void)
{
    
        u8 KEY_BUF=0,TEMP;
	
    	
    	if(SOUND_KEY_IN==0)
    		KEY_BUF|=0X04;
    
    	    
			
  	if((f_key_release!=0)&&(KEY_BUF==0))//do key release
  	   {
	       if(f_unit_on)
                   Delayn(20);
		  
		
    		if(SOUND_KEY_IN==0)
    		   KEY_BUF|=0X04;
    		
		  if(KEY_BUF==0)
		   {
  		      f_key_release=0;
  		      f_en_tx=0;
  		      tx_cmd=0;
  		      key_name=c_none_key;

  		     } 
  		  
  	 }
  	 

	else if(KEY_BUF!=0)  //press
	 {
	    	if(f_unit_on)
		   Delayn(20);
	     	
	     	TEMP=KEY_BUF;
	     	KEY_BUF=0;
		
    		if(SOUND_KEY_IN==0)
    		    KEY_BUF|=0X04;
    		
		if(KEY_BUF==TEMP)
	         {
		    
			gb_auto_sleep_cnt=c_sleep_time;//	10min=600s
		     	f_unit_on=1;
		   	if(f_unit_on==0)//&&(f_just_off!=1))
		          {
		  		//f_turn_on=1;
		  		f_unit_on=1;
		  		f_key_release=1;
				 //return;
			
		          }
              

		     if(key_name==c_none_key)
		         {
		      	    
			    if(KEY_BUF==0X04)
			       key_name=c_sound_key;
			   
				
			 //	 SendOut(key_name);

                 f_key_release=1;
			     gb_auto_sleep_cnt=c_sleep_time;//	10min=600s
			 
			    switch( key_name)
			    {
			 	
				
			 	     
		     	       case c_sound_key:
		      	      	
				     f_en_tx=1;
                                     f_como=1;//continous
			 	     gb_mode=c_bzmode;
			 	     ch_no=c_ch1no;
			 	     
			 	     break;      
		  	     
		  
		  	    default:
		  		    break;
			   }
				
	           }

	     }
     }	             
    

}

/**********************************************************
**Name:    
**Function: 
**Input:    none
**Output:   none
**********************************************************/	

//============================== 
 void led_color(void)
 {
    	switch(gb_bat_status)
	{
	  case c_full_G:
	  	RLED=1;
	  	GLED=0;
	  	break;
	  case c_half_O:
	  	RLED=1;
	  	GLED=0;
	  	break;
	  case c_low_R:
	  	RLED=0;
	  	GLED=1;
	  	break;
	  default:
	 	break; 	
	
	
	}
}

 


 /**********************************************************
**Name:     isp
**Function: 
**Input:    none
**Output:   none
**********************************************************/
void Enable_ISP(void)
{
	ISPCN=0X30;		//select standby mode
	EA=0;
	TA=0XAA;
	TA=0X55;
	CHPCON|=0X1;			//ISPEN=1,enable ISP function
	EA=1;
	Trigger_ISP();
}

void Close_ISP(void)
{
	ISPCN=0X30;
	Trigger_ISP();
	EA=0;
	TA=0XAA;
	TA=0X55;
	CHPCON&=0XFE;			//ISPEN=0, disable ISP function
	EA=1;

}

void Trigger_ISP(void)
{
	EA=0;
	TA=0XAA;
	TA=0X55;
	ISPTRG=0X01;			//write 1 to bit ISPG0 to trigger and ISP processing
	EA=1;

}

//void FLASH_PAGE_Erase(u16 target_flash_addr)
void FLASH_PAGE_Erase(void)
{
    u8 i;
	Enable_ISP();
	ISPCN=0X22;

	ISPAH=0X30;
	ISPAL=0X00;				   //fill page address(128pages, page0/1/2/3..: 0000h,0080h,0100h,0180h,,,
	Trigger_ISP();

 for(i=0;i<128;i++)
    {
        ISPAL = i;
        Trigger_ISP();
    }
	Close_ISP();
}

void FLASH_Program_ID(void)
{	
	Enable_ISP();
	ISPCN=0X21;					//select flash program mode, (A17,A16)=(0,0) for APROM/Data Flash/LDROM
	ISPAH=0X30;
	ISPAL=0X00;					//fill byte address
    
	ISPFD=0X55;
	Trigger_ISP();
    	ISPAL++;
	ISPFD=0X66;					//SPECIAL VALUE
	Trigger_ISP();
	ISPAL++;

	ISPFD=gb_LocalIDL;
	Trigger_ISP();
        ISPAL++;
	ISPFD=gb_LocalIDH;			//fill data to be programed
	Trigger_ISP();
	ISPAL++;
	ISPFD=gb_LocalIDL;
	Trigger_ISP();
	ISPAL++;
	ISPFD=gb_LocalIDH;
	Trigger_ISP();
	
	ISPAL++;
	ISPFD=gb_LocalModel;
	Trigger_ISP();
	ISPAL++;
	ISPFD=gb_LocalModel;
	Trigger_ISP();
	

	Close_ISP();

}

void FLASH_Read_ID(void)
{
        gb_LocalIDL=0;
	gb_LocalIDH=0;
 	Enable_ISP();
	ISPCN=0X00;					//Select Flash read mode
	ISPAH=0X1f;	//1ff0~1ff7
	ISPAL=0Xf2;					//fill byte address

	Trigger_ISP();
	gb_Temp[0]=ISPFD;  
	ISPAL++;

	Trigger_ISP();
	gb_Temp[1]=ISPFD;
	ISPAL++;

	Trigger_ISP();
	gb_Temp[2]=ISPFD;
	ISPAL++;

	Trigger_ISP();
	gb_Temp[3]=ISPFD;
	ISPAL++;
	
	Trigger_ISP();
	gb_Temp[4]=ISPFD;
	ISPAL++;
	
	Trigger_ISP();
	gb_Temp[5]=ISPFD;
	gb_LocalIDL=gb_Temp[5];
	gb_LocalIDH=gb_Temp[4];
	Close_ISP();
}



/**********************************************************
**Name:    
**Function: 
**Input:    none
**Output:   none
**********************************************************/
/**********************************************************
**Name:    
**Function: 
**Input:    none
**Output:   none
// 
**********************************************************/
 void Delayn(unsigned char tt)
{
	unsigned char i;
	unsigned char j;
	
	for(i=tt; i>0; i--)   //
	{
		for(j=250;j>0;j--)     //1ms
		{
		 _nop_ ();
		 _nop_ ();
		 _nop_ ();
		 _nop_ ();
		_nop_ ();
		 _nop_ ();
		 _nop_ ();
		 _nop_ ();
	 }	
   }	 
}   







//===============================



//-----------------------------------------------------------------------------------------------------------
/*void Send_Data_To_PC (u8 c)
{
    while (!TI);
    TI = 0;
    SBUF = c;
} */
//--------





//********************************************************************************/
//#define  UART_SEND_Pin GPIO4        //GPIO4=TXD
//********************************************************************************
void BPS_Delay(void){

       u8 i;
	   for(i=0;i<20;i++)
	   {
	   ;
	   }

}
//*********************************************************************************
//һ			19200
//*********************************************************************************
void SendOut(unsigned char tx_buf)
{
      
      /*  
        unsigned char i,Dat;           
                i=8;                                                  //19200 8.n 1        P d8 S
                sim_uart_tx=0;                        //ʼλ
                sim_uart_tx1=0;
                BPS_Delay();
                Dat=tx_buf;
                while(i--){
                        sim_uart_tx=(bit)(Dat & 0x01);
                        Dat>>=1;        
                        BPS_Delay();
                }
                sim_uart_tx=1;
                sim_uart_tx1=1;
                BPS_Delay();        
     	      */
}




//===============================



/*eof*/ 